#!/bin/csh -f
#
# Usage: install_parallel.csh mc-tinker_path amber_path
#
# C shell script used to compile a parallel version of AMBERPLUS
#
if ($#argv != 2) then
   echo "Usage: install_parallel.csh mc-tinker_path amber_path"
   echo "For example: install_parallel.csh /usr/mcsi-2010-1 /usr/amber11 "
   exit 1
endif
#
set mctdir = $argv[1]
set ambdir = $argv[2]
set ampdir = `pwd`
#
set amsdir = $ambdir/src
set exedir = $ambdir/exe
#
set snddir = $amsdir/sander
#
cd $amsdir
make clean
#
cd $snddir
make sanderplus.MPI
#
mv sanderplus.MPI $exedir/sanderplus.MPI
