      module mcinter
!
!     this module contains interface variables 
!     between MC-TINKER and SANDER.
!
!     file names and unit number for MCMM calculation.
!     esp.fu84 and esp.fu86 is not used.
!     mcchg and mcelp are used for outputs of 
!     EE-MCMM charge and electrostatic potential on each atom.
!
      character(len=256) esp81,esp82,esp83,esp85,mcprm
      character(len=256) mcchg,mcelp,mcene
!
!      integer   fu81,fu82,fu83,fu85,fuprm
      integer   iochg,ioelp
!      parameter ( fu81=81 )
!      parameter ( fu82=82 )
!      parameter ( fu83=83 )
!      parameter ( fu85=85 )
!      parameter ( fuprm=79 )
      parameter ( iochg=91 )
      parameter ( ioelp=92 )
      parameter ( ioene=93 )
!
!     flag for calculating MCMM
!     imcmm = 1 if qmthoery=8 in &qmmm namelist.
!
      integer imcmm
!
!     flag for outputs
!
      integer nstpchg,ifmtchg
      integer nstpelp,ifmtelp
      integer nstpene,ifmtene
!
!     flag for QM/MM electrostatic interaction near the QM/MM boundary
!
      integer iqmmmbd
      integer, parameter :: mxbchg=20
      integer nbchg, ibchgp(2,mxbchg)
      real*8 bndchg(mxbchg)
!
!     mxmcat means the maximum number of atoms
!     which can be used in (EE-)MCMM calculations.
!
      integer, parameter :: mxmcat=25
!
!     array of MCMM atoms (including link atoms)
!
      integer imcatm(mxmcat)
!
!     store each qm-mm interaction 
!
      integer, parameter :: mxmmat=6000
      integer npmcmm(mxmcat)
      integer ipmcmm(mxmmat,mxmcat)
      real*8 dmcmmx(mxmmat,mxmcat)
      real*8 dmcmmy(mxmmat,mxmcat)
      real*8 dmcmmz(mxmmat,mxmcat)
!
!     array of electrostatic potential
!
      real*8 phir(mxmcat)
!
!     store diagonal matrix and EE-MCMM energy
!
      real*8 vmc11,vmc22,vmc12,vmceig,vintlj
!
      end module mcinter
