! <compile=optimized>
#include "../include/dprec.fh"
!
 module tapering
!
! this module contains variables used in tapering calculation.
!
   implicit none
   integer itaper
   _REAL_  ctaper
   _REAL_  rcl,rcs,rch,rch1
   _REAL_  ct0,ct1,ct2,ct3,ct4,ct5
   _REAL_  ft0,ft1,ft2,ft3,ft4,ft5,ft6,ft7
 end module tapering
!
 subroutine taperset
!
! this subroutine sets up tapering method
!
   use tapering
   implicit none
#  include "box.h"
#  include "ew_cntrl.h"
#  include "ew_erfc_spline.h"
   _REAL_ rcl2,rcl3,rcl4,rcl5,rcl6,rcl7
   _REAL_ rcs2,rcs3,rcs4,rcs5,rcs6,rcs7
   _REAL_ denom,term
!
   rcl=sqrt(cut)
   if(itaper==0) return
!
   rcs=ctaper*rcl
   rch=0.5d+00*(rcl+rcs)
   rch1=1.0d+00/rch
!
   rcl2=rcl*rcl
   rcl3=rcl2*rcl
   rcl4=rcl2*rcl2
   rcl5=rcl2*rcl3
   rcl6=rcl3*rcl3
   rcl7=rcl3*rcl4
   rcs2=rcs*rcs
   rcs3=rcs2*rcs
   rcs4=rcs2*rcs2
   rcs5=rcs2*rcs3
   rcs6=rcs3*rcs3
   rcs7=rcs3*rcs4
!
   denom=(rcl-rcs)**5
   ct0=rcl*rcl2*(rcl2-5.0d+00*rcl*rcs+10.0d+00*rcs2)/denom
   ct1=-30.0d+00*rcl2*rcs2/denom
   ct2= 30.0d+00*(rcl2*rcs+rcl*rcs2)/denom
   ct3=-10.0d+00*(rcl2+4.0d+00*rcl*rcs+rcs2)/denom
   ct4= 15.0d+00*(rcl+rcs)/denom
   ct5= -6.0d+00/denom
!
   term=9.3d+00*rcs*rcl/(rcl-rcs)
   denom=rcs7-7.0d+00*rcs6*rcl+21.0d+00*rcs5*rcl2  &
        -35.0d+00*rcs4*rcl3+35.0d+00*rcs3*rcl4     &
        -21.0d+00*rcs2*rcl5+7.0d+00*rcs*rcl6-rcl7
   denom=term*denom
   ft0=rcs3*rcl3*(-39.0d+00*rcs+64.0d+00*rcl)/denom
   ft1=rcs2*rcl2 &
      *(117.0d+00*rcs2-100.0d+00*rcs*rcl-192.0d+00*rcl2)/denom
   ft2=rcs*rcl*(-117.0d+00*rcs3-84.0d+00*rcs2*rcl &
      +534.0d+00*rcs*rcl2+192.0d+00*rcl3)/denom
   ft3=(39.0d+00*rcs4+212.0d+00*rcs3*rcl-450.0d+00*rcs2*rcl2 &
      -612.0d+00*rcs*rcl3-64.0d+00*rcl4)/denom
   ft4=(-92.0d+00*rcs3+66.0d+00*rcs2*rcl &
      +684.0d+00*rcs*rcl2+217.0d+00*rcl3)/denom
   ft5=(42.0d+00*rcs2-300.0d+00*rcs*rcl-267.0d+00*rcl2)/denom
   ft6=(36.0d+00*rcs+139.0d+00*rcl)/denom
   ft7=-25.0d+00/denom
!
!   write(6,*) 'rcl=',rcl
!   write(6,*) 'rcs=',rcs
!   write(6,*) 'rch=',rch
!
   return   
 end subroutine taperset
